/* Jeff DeMaagd
Date: 08/08/1998

Licence:
GNU General Public Licence (GPL).  See the file attached to this package
for more information.

Purpose:
this program tests to see if all parantheses and bracket types are balanced.
not extremely useful except in debugging program output, or you think you
overlooked something.  My own libcam is an example. Emacs does the job when
you are typing something.  */

#include <stdio.h>

int main (int argc, char *argv[])
{
	char character = 0;
	short int	left_par = 0,		right_par = 0, 
			left_brkt = 0,		right_brkt = 0,
			left_box = 0,		right_box = 0,
			left_angle = 0,		right_angle = 0,
			quote_mark = 0,		tick_mark = 0,
			back_slash = 0,		fore_slash = 0;
	FILE *file_in;


        printf ("\n    Jeff DeMaagd Command Line Utilities, (c) 1998, licenced under GPL.\n");
        printf ("\tbalance\tan output file checker\n\n");

	file_in = fopen(argv[1],"r");
	if (file_in == NULL)
	{	/* an error occured in oppening file */
                printf ("\tsyntax:\tbalance [input file name]\n\n");
	}
	else
	{
		printf ("    Input File:\t%s\n", argv[1]);
		character = getc(file_in);

		while (character != EOF)
		{
			switch (character)
			{
				case ('(') : { left_par++;	break; }
				case (')') : { right_par++;	break; }
				case ('{') : { left_brkt++;	break; }
				case ('}') : { right_brkt++;	break; }
				case ('[') : { left_box++;	break; }
				case (']') : { right_box++;	break; }
				case ('<') : { left_angle++;	break; }
				case ('>') : { right_angle++;	break; } 
				case ('"') : { quote_mark++;	break; }
				case ('\'') : { tick_mark++;	break; }
				case ('\\') : { back_slash++;	break; }
				case ('/') : { fore_slash++;	break; }
			}
			character = getc(file_in);
		}
		fclose (file_in);

		printf ("\t\'(\':\t%d\t\')\':\t%d\n",   left_par,   right_par   );
		printf ("\t\'{\':\t%d\t\'}\':\t%d\n",   left_brkt,  right_brkt  );
		printf ("\t\'[\':\t%d\t\']\':\t%d\n",   left_box,   right_box   );
		printf ("\t\'<\':\t%d\t\'>\':\t%d\n",   left_angle, right_angle );
		printf ("\t\'\"\':\t%d\t\'\'\':\t%d\n", quote_mark, tick_mark); 
		printf ("\t\'\\\':\t%d\t\'/\':\t%d\n\n", back_slash, fore_slash);

		if ((left_par == right_par) && (left_brkt == right_brkt) &&
			(left_box == right_box) && (left_angle == right_angle))
		{	
			printf ("    All bracket characters seem to balance fine.\n\n");
		}
		else
		{
			printf ("Error:");
			if (left_par != right_par)
			{
				printf ("\tThe parentheses do not seem to balance.\n");
			}

			if (left_brkt != right_brkt)
			{
				printf ("\tThe curly brackets do not seem to balance.\n");
			}

			if (left_box != right_box)
			{
				printf ("\tThe box brackets do not seem to balance.\n");
			}

			if (left_angle != right_angle)
			{
				printf ("\tThe angle brackets do not seem to balance.\n");
			}

			printf ("\n");
		}
	}
	return(0);
}

/*	I have these in to show what this program can pick up
}
[
)
>
*/
